﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Mover : MonoBehaviour
{
    public Vector3 startingPosition;
    public Vector3 endingPosition;
    public float MaxTimeInSeconds = 3.0f;

    float timer = 0.0f;
	
	// Update is called once per frame
	void Update ()
    {
        float t = timer / MaxTimeInSeconds;
        Vector3 currentPosition = Vector3.Lerp(startingPosition, endingPosition, Mathf.Clamp01(t));
        this.transform.position = currentPosition;

        if (t >= 1.0f)
        {
            Vector3 tempVec = startingPosition;
            startingPosition = endingPosition;
            endingPosition = tempVec;
            timer = 0.0f;
        }
        else
            timer += Time.smoothDeltaTime;
	}
}
