cbuffer ConstantBufferData
{
	float4x4 matrixWorld;
	float4x4 matrixView;
	float4x4 matrixProjection;
};

struct v2f
{
	float4 position : SV_POSITION;
	float2 uv : TEXCOORD;
};

v2f main(float4 position : POSITION, float4 normal : NORMAL, float4 tangent : TANGENT, float2 uv : TEXCOORD)
{
	v2f o;

    float4x4 mvp = mul(matrixWorld, mul(matrixView, matrixProjection));
	o.position = mul(float4(position.xyz, 1.0), mvp);
	o.uv = uv;

	return o;
}