@ECHO OFF

set script_dir=%~dp0
set "fxc_path=%script_dir%..\build_tools\directx\fxc.exe"
REM echo %fxc_path%

set old_cd=%cd%
cd %script_dir%

IF "%~1"=="-r" GOTO COMPILE_RELEASE
IF "%~1"=="-d" GOTO COMPILE_DEBUG
IF "%~1"=="-h" GOTO HELP
IF "%~1"=="-help" GOTO HELP
IF "%~1"=="?" GOTO HELP
GOTO INVALID_PARAMETERS

REM For Command line shader compiler information, check out
REM https://msdn.microsoft.com/en-us/library/windows/desktop/bb509710(v=vs.85).aspx

:COMPILE_RELEASE
echo "Compiling shaders in release"
%fxc_path% /T vs_5_0 /Fo VertexShader.fxc VertexShader.hlsl 
%fxc_path% /T ps_5_0 /Fo PixelShader.fxc PixelShader.hlsl 
GOTO LINK

:COMPILE_DEBUG
echo "Compiling shaders in debug"
%fxc_path% /Od /Zi /T vs_5_0 /Fo VertexShader.fxc VertexShader.hlsl 
%fxc_path% /Od /Zi /T ps_5_0 /Fo PixelShader.fxc PixelShader.hlsl 

GOTO LINK

:HELP
echo "compile_all_shaders.bat -r|-d"
GOTO DONE

:INVALID_PARAMETERS
echo "Error: Invalid command line arguments.  Try compile_all_shaders.bat -help for correct usage information."
exit /b 1
GOTO DONE

:LINK
echo "Statically Linking Shaders..."
echo "Building VertexShader.h from vertex shader byte code."
tocheaderfile.py VertexShader.fxc ..\src\VertexShader.h vertexShaderByteCode
echo "Building PixelShader.h from pixel shader byte code."
tocheaderfile.py PixelShader.fxc ..\src\PixelShader.h pixelShaderByteCode
GOTO DONE

:DONE

cd %old_cd%

@ECHO ON