import os;
import struct;
import argparse;
 
def beginArray(outputFile, arrayName, arraySize):
    outputFile.write("unsigned char {0}[{1}] =\n".format(arrayName, inputFileSize));
    outputFile.write("{\n");
 
def endArray(outputFile):
    outputFile.write("};");
 
def writeByteIntoArray(outputFile, index, byte, indicesPerLine, arraySize, useIntFormat):
    byteAsNumber = struct.unpack('B', byte)[0];
 
    valuePrefix = "(unsigned char)";
 
    if useIntFormat is False:
        byteAsNumber = hex(byteAsNumber);
        valuePrefix = "";
 
    if (index) % indicesPerLine  == 0:
        outputFile.write("\t");
 
    line = "";
    if arraySize > 1 and index < arraySize-1:
        line = "{0}{1}, ".format(valuePrefix, byteAsNumber);
        if (index+1) % indicesPerLine  == 0:
            line = line + "\n";
    else:
        line = "{0}{1}\n".format(valuePrefix, byteAsNumber);
    outputFile.write(line);
 
 
parser = argparse.ArgumentParser("tocheaderfile");
parser.add_argument("inputFilePath", help="The path to a file to be converted into a c header file.", type=str);
parser.add_argument("outputFilePath", help="The path to the header file that will be generated.", type=str);
parser.add_argument("arrayName", help="The name of the array in the generated header file.", type=str);
parser.add_argument("-int", help="Integer values will be used to populate the array", action="store_true")
args = parser.parse_args();
 
inputFilePath = args.inputFilePath;
outputFilePath = args.outputFilePath;
arrayName = args.arrayName;
useIntFormat = args.int;
bytesPerLine = 5;
 
inputFileSize = os.path.getsize(inputFilePath);
 
outputFile = open(outputFilePath, "w");
beginArray(outputFile, arrayName, inputFileSize);
 
inputFile = open(inputFilePath, "rb");
try:
    for index in range(0, inputFileSize):
        byte = inputFile.read(1);
        writeByteIntoArray(outputFile, index, byte, bytesPerLine, inputFileSize, useIntFormat);
finally:
    inputFile.close();
 
endArray(outputFile);
 
outputFile.close();
 
print("DONE!");